/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         zp_parse
#define yylex           zp_lex
#define yyerror         zp_error
#define yylval          zp_lval
#define yychar          zp_char
#define yydebug         zp_debug
#define yynerrs         zp_nerrs


/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "zparser.y"

/*!
 * \file zparser.y
 *
 * \author modifications by Jan Kadlec <jan.kadlec@nic.cz>,
 *         notable changes: normal allocation, parser is reentrant.
 *         most of the code by NLnet Labs
 *         Copyright (c) 2001-2011, NLnet Labs. All rights reserved.
 *
 * \brief yacc grammar for (DNS) zone files
 *
 * \addtogroup zoneparser
 * @{
 */

/*
 * Copyright (c) 2001-2011, NLnet Labs. All rights reserved.
 *
 * This software is open source.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * Neither the name of the NLNET LABS nor the names of its contributors may
 * be used to endorse or promote products derived from this software without
 * specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

//#include "common.h"

#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>

#include "zcompile/parser-util.h"
#include "common/log.h"

#include "libknot/libknot.h"
#include "zcompile/zcompile.h"
#include "zcompile/parser-descriptor.h"
#include "zcompile/zcompile-error.h"
#include "zparser.h"

/* these need to be global, otherwise they cannot be used inside yacc */
zparser_type *parser;

#ifdef __cplusplus
extern "C"
#endif /* __cplusplus */
int zp_wrap(void);

/* this hold the nxt bits */
static uint8_t nxtbits[16];
static int dlv_warn = 1;

/* 256 windows of 256 bits (32 bytes) */
/* still need to reset the bastard somewhere */
static uint8_t nsecbits[NSEC_WINDOW_COUNT][NSEC_WINDOW_BITS_SIZE];

/* hold the highest rcode seen in a NSEC rdata , BUG #106 */
uint16_t nsec_highest_rcode;

void zp_error(void *scanner, const char *message);
int zp_lex(YYSTYPE *lvalp, void *scanner);

/* helper functions */
void zc_error(const char *fmt, ...);
void zc_warning(const char *fmt, ...);
void zc_error_prev_line(const char *fmt, ...);
void zc_warning_prev_line(const char *fmt, ...);

#define NSEC3
#ifdef NSEC3
/* parse nsec3 parameters and add the (first) rdata elements */
static void
nsec3_add_params(const char* hash_algo_str, const char* flag_str,
	const char* iter_str, const char* salt_str, int salt_len);
#endif /* NSEC3 */

knot_dname_t *error_dname; //XXX used to be const
knot_dname_t *error_domain;



/* Line 268 of yacc.c  */
#line 185 "zparser.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     T_A = 258,
     T_NS = 259,
     T_MX = 260,
     T_TXT = 261,
     T_CNAME = 262,
     T_AAAA = 263,
     T_PTR = 264,
     T_NXT = 265,
     T_KEY = 266,
     T_SOA = 267,
     T_SIG = 268,
     T_SRV = 269,
     T_CERT = 270,
     T_LOC = 271,
     T_MD = 272,
     T_MF = 273,
     T_MB = 274,
     T_MG = 275,
     T_MR = 276,
     T_NULL = 277,
     T_WKS = 278,
     T_HINFO = 279,
     T_MINFO = 280,
     T_RP = 281,
     T_AFSDB = 282,
     T_X25 = 283,
     T_ISDN = 284,
     T_RT = 285,
     T_NSAP = 286,
     T_NSAP_PTR = 287,
     T_PX = 288,
     T_GPOS = 289,
     T_EID = 290,
     T_NIMLOC = 291,
     T_ATMA = 292,
     T_NAPTR = 293,
     T_KX = 294,
     T_A6 = 295,
     T_DNAME = 296,
     T_SINK = 297,
     T_OPT = 298,
     T_APL = 299,
     T_UINFO = 300,
     T_UID = 301,
     T_GID = 302,
     T_UNSPEC = 303,
     T_TKEY = 304,
     T_TSIG = 305,
     T_IXFR = 306,
     T_AXFR = 307,
     T_MAILB = 308,
     T_MAILA = 309,
     T_DS = 310,
     T_DLV = 311,
     T_SSHFP = 312,
     T_RRSIG = 313,
     T_NSEC = 314,
     T_DNSKEY = 315,
     T_SPF = 316,
     T_NSEC3 = 317,
     T_IPSECKEY = 318,
     T_DHCID = 319,
     T_NSEC3PARAM = 320,
     T_TLSA = 321,
     DOLLAR_TTL = 322,
     DOLLAR_ORIGIN = 323,
     NL = 324,
     SP = 325,
     NO_MEM = 326,
     STR = 327,
     PREV = 328,
     BITLAB = 329,
     T_TTL = 330,
     T_RRCLASS = 331,
     URR = 332,
     T_UTYPE = 333
   };
#endif
/* Tokens.  */
#define T_A 258
#define T_NS 259
#define T_MX 260
#define T_TXT 261
#define T_CNAME 262
#define T_AAAA 263
#define T_PTR 264
#define T_NXT 265
#define T_KEY 266
#define T_SOA 267
#define T_SIG 268
#define T_SRV 269
#define T_CERT 270
#define T_LOC 271
#define T_MD 272
#define T_MF 273
#define T_MB 274
#define T_MG 275
#define T_MR 276
#define T_NULL 277
#define T_WKS 278
#define T_HINFO 279
#define T_MINFO 280
#define T_RP 281
#define T_AFSDB 282
#define T_X25 283
#define T_ISDN 284
#define T_RT 285
#define T_NSAP 286
#define T_NSAP_PTR 287
#define T_PX 288
#define T_GPOS 289
#define T_EID 290
#define T_NIMLOC 291
#define T_ATMA 292
#define T_NAPTR 293
#define T_KX 294
#define T_A6 295
#define T_DNAME 296
#define T_SINK 297
#define T_OPT 298
#define T_APL 299
#define T_UINFO 300
#define T_UID 301
#define T_GID 302
#define T_UNSPEC 303
#define T_TKEY 304
#define T_TSIG 305
#define T_IXFR 306
#define T_AXFR 307
#define T_MAILB 308
#define T_MAILA 309
#define T_DS 310
#define T_DLV 311
#define T_SSHFP 312
#define T_RRSIG 313
#define T_NSEC 314
#define T_DNSKEY 315
#define T_SPF 316
#define T_NSEC3 317
#define T_IPSECKEY 318
#define T_DHCID 319
#define T_NSEC3PARAM 320
#define T_TLSA 321
#define DOLLAR_TTL 322
#define DOLLAR_ORIGIN 323
#define NL 324
#define SP 325
#define NO_MEM 326
#define STR 327
#define PREV 328
#define BITLAB 329
#define T_TTL 330
#define T_RRCLASS 331
#define URR 332
#define T_UTYPE 333




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 105 "zparser.y"

	knot_dname_t       *domain;
	knot_dname_t       *dname;
	struct lex_data      data;
	uint32_t             ttl;
	uint16_t             rclass;
	uint16_t             type;
	uint16_t             *unknown;



/* Line 293 of yacc.c  */
#line 389 "zparser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 401 "zparser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   837

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  81
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  64
/* YYNRULES -- Number of rules.  */
#define YYNRULES  199
/* YYNRULES -- Number of states.  */
#define YYNSTATES  486

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   333

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,    79,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    80,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    12,    14,    17,    19,
      21,    23,    26,    28,    31,    33,    36,    41,    46,    51,
      55,    58,    60,    61,    64,    67,    72,    77,    79,    81,
      83,    85,    88,    90,    92,    94,    98,   100,   102,   104,
     107,   109,   111,   115,   117,   121,   123,   125,   129,   133,
     135,   139,   142,   144,   147,   149,   152,   154,   158,   160,
     164,   166,   168,   171,   175,   179,   183,   187,   191,   195,
     199,   203,   207,   211,   215,   219,   223,   227,   231,   235,
     239,   243,   247,   251,   255,   259,   263,   267,   271,   275,
     279,   283,   287,   291,   295,   299,   303,   307,   311,   315,
     319,   323,   327,   331,   335,   339,   343,   347,   351,   355,
     359,   363,   367,   371,   375,   379,   383,   387,   391,   395,
     399,   403,   407,   411,   415,   419,   423,   427,   431,   435,
     439,   443,   447,   451,   455,   458,   462,   466,   470,   474,
     478,   482,   486,   490,   494,   498,   502,   506,   510,   514,
     518,   522,   526,   530,   534,   538,   542,   546,   548,   551,
     554,   569,   576,   581,   586,   591,   594,   599,   604,   607,
     610,   615,   620,   623,   630,   633,   636,   641,   650,   663,
     668,   677,   680,   682,   686,   695,   704,   711,   714,   733,
     736,   747,   756,   765,   774,   782,   787,   790,   797,   802
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      82,     0,    -1,    -1,    82,    83,    -1,    69,    -1,    84,
      69,    -1,    71,    -1,    73,    69,    -1,    86,    -1,    87,
      -1,    88,    -1,     1,    69,    -1,    70,    -1,    84,    70,
      -1,    69,    -1,    84,    69,    -1,    67,    84,    72,    85,
      -1,    68,    84,    92,    85,    -1,    68,    84,    94,    85,
      -1,    89,    90,   107,    -1,    91,    84,    -1,    73,    -1,
      -1,    76,    84,    -1,    75,    84,    -1,    75,    84,    76,
      84,    -1,    76,    84,    75,    84,    -1,    92,    -1,    94,
      -1,    79,    -1,    80,    -1,    94,    79,    -1,    72,    -1,
      74,    -1,    93,    -1,    94,    79,    93,    -1,    96,    -1,
      98,    -1,    79,    -1,    98,    79,    -1,    72,    -1,    97,
      -1,    98,    79,    97,    -1,    72,    -1,    99,    84,    72,
      -1,    72,    -1,    79,    -1,   100,    84,    72,    -1,   100,
      79,    72,    -1,    72,    -1,   101,    84,    72,    -1,    70,
     102,    -1,    69,    -1,    72,   103,    -1,    69,    -1,    70,
     102,    -1,    72,    -1,   104,    84,    72,    -1,    72,    -1,
     105,    79,    72,    -1,    72,    -1,    79,    -1,   106,    79,
      -1,   106,    79,    72,    -1,     3,    84,   108,    -1,     3,
      84,   144,    -1,     4,    84,   109,    -1,     4,    84,   144,
      -1,    17,    84,   109,    -1,    17,    84,   144,    -1,    18,
      84,   109,    -1,    18,    84,   144,    -1,     7,    84,   109,
      -1,     7,    84,   144,    -1,    12,    84,   110,    -1,    12,
      84,   144,    -1,    19,    84,   109,    -1,    19,    84,   144,
      -1,    20,    84,   109,    -1,    20,    84,   144,    -1,    21,
      84,   109,    -1,    21,    84,   144,    -1,    23,    84,   111,
      -1,    23,    84,   144,    -1,     9,    84,   109,    -1,     9,
      84,   144,    -1,    24,    84,   112,    -1,    24,    84,   144,
      -1,    25,    84,   113,    -1,    25,    84,   144,    -1,     5,
      84,   114,    -1,     5,    84,   144,    -1,     6,    84,   115,
      -1,     6,    84,   144,    -1,    61,    84,   115,    -1,    61,
      84,   144,    -1,    26,    84,   116,    -1,    26,    84,   144,
      -1,    27,    84,   117,    -1,    27,    84,   144,    -1,    28,
      84,   118,    -1,    28,    84,   144,    -1,    29,    84,   119,
      -1,    29,    84,   144,    -1,    63,    84,   143,    -1,    63,
      84,   144,    -1,    64,    84,   135,    -1,    64,    84,   144,
      -1,    30,    84,   120,    -1,    30,    84,   144,    -1,    31,
      84,   121,    -1,    31,    84,   144,    -1,    13,    84,   136,
      -1,    13,    84,   144,    -1,    11,    84,   141,    -1,    11,
      84,   144,    -1,    33,    84,   122,    -1,    33,    84,   144,
      -1,     8,    84,   123,    -1,     8,    84,   144,    -1,    16,
      84,   124,    -1,    16,    84,   144,    -1,    10,    84,   125,
      -1,    10,    84,   144,    -1,    14,    84,   126,    -1,    14,
      84,   144,    -1,    38,    84,   127,    -1,    38,    84,   144,
      -1,    39,    84,   128,    -1,    39,    84,   144,    -1,    15,
      84,   129,    -1,    15,    84,   144,    -1,    41,    84,   109,
      -1,    41,    84,   144,    -1,    44,    85,    -1,    44,    84,
     130,    -1,    44,    84,   144,    -1,    55,    84,   132,    -1,
      55,    84,   144,    -1,    56,    84,   133,    -1,    56,    84,
     144,    -1,    57,    84,   134,    -1,    57,    84,   144,    -1,
      58,    84,   136,    -1,    58,    84,   144,    -1,    59,    84,
     137,    -1,    59,    84,   144,    -1,    62,    84,   138,    -1,
      62,    84,   144,    -1,    65,    84,   139,    -1,    65,    84,
     144,    -1,    66,    84,   140,    -1,    66,    84,   144,    -1,
      60,    84,   141,    -1,    60,    84,   144,    -1,    78,    84,
     144,    -1,    72,     1,    69,    -1,    71,    -1,   106,    85,
      -1,    91,    85,    -1,    91,    84,    91,    84,    72,    84,
      72,    84,    72,    84,    72,    84,    72,    85,    -1,   106,
      84,    72,    84,   100,    85,    -1,    72,    84,    72,    85,
      -1,    91,    84,    91,    85,    -1,    72,    84,    91,    85,
      -1,    99,    85,    -1,    91,    84,    91,    85,    -1,    72,
      84,    91,    85,    -1,    72,    85,    -1,    72,    85,    -1,
      72,    84,    72,    85,    -1,    72,    84,    91,    85,    -1,
     105,    85,    -1,    72,    84,    91,    84,    91,    85,    -1,
     106,    85,    -1,   100,    85,    -1,    91,    84,   101,    85,
      -1,    72,    84,    72,    84,    72,    84,    91,    85,    -1,
      72,    84,    72,    84,    72,    84,    72,    84,    72,    84,
      91,    85,    -1,    72,    84,    91,    85,    -1,    72,    84,
      72,    84,    72,    84,   104,    85,    -1,   131,    85,    -1,
     106,    -1,   131,    84,   106,    -1,    72,    84,    72,    84,
      72,    84,   104,    85,    -1,    72,    84,    72,    84,    72,
      84,   104,    85,    -1,    72,    84,    72,    84,   104,    85,
      -1,   104,    85,    -1,    72,    84,    72,    84,    72,    84,
      72,    84,    72,    84,    72,    84,    72,    84,    95,    84,
     104,    85,    -1,    95,   103,    -1,    72,    84,    72,    84,
      72,    84,    72,    84,    72,   103,    -1,    72,    84,    72,
      84,    72,    84,    72,    85,    -1,    72,    84,    72,    84,
      72,    84,   104,    85,    -1,    72,    84,    72,    84,    72,
      84,   104,    85,    -1,    72,    84,    72,    84,    72,    84,
     106,    -1,   142,    84,   104,    85,    -1,   142,    85,    -1,
      77,    84,    72,    84,   104,    85,    -1,    77,    84,    72,
      85,    -1,    77,     1,    69,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   150,   150,   151,   154,   155,   156,   160,   161,   165,
     169,   282,   286,   287,   290,   291,   294,   309,   318,   325,
     335,   348,   358,   362,   367,   372,   377,   384,   385,   401,
     406,   411,   421,   434,   442,   443,   463,   464,   467,   483,
     505,   531,   532,   560,   569,   584,   585,   590,   611,   635,
     646,   659,   662,   665,   681,   682,   689,   690,   717,   718,
     744,   745,   750,   770,   800,   801,   802,   803,   804,   805,
     810,   811,   817,   818,   819,   820,   821,   822,   828,   829,
     830,   831,   833,   834,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   867,   868,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     897,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   920,   922,   927,   940,   947,
     961,   992,  1004,  1014,  1033,  1046,  1053,  1068,  1082,  1092,
    1099,  1112,  1126,  1142,  1158,  1167,  1175,  1186,  1204,  1229,
    1242,  1260,  1263,  1269,  1277,  1291,  1305,  1317,  1325,  1365,
    1387,  1415,  1430,  1444,  1458,  1529,  1535,  1538,  1545,  1550
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_A", "T_NS", "T_MX", "T_TXT",
  "T_CNAME", "T_AAAA", "T_PTR", "T_NXT", "T_KEY", "T_SOA", "T_SIG",
  "T_SRV", "T_CERT", "T_LOC", "T_MD", "T_MF", "T_MB", "T_MG", "T_MR",
  "T_NULL", "T_WKS", "T_HINFO", "T_MINFO", "T_RP", "T_AFSDB", "T_X25",
  "T_ISDN", "T_RT", "T_NSAP", "T_NSAP_PTR", "T_PX", "T_GPOS", "T_EID",
  "T_NIMLOC", "T_ATMA", "T_NAPTR", "T_KX", "T_A6", "T_DNAME", "T_SINK",
  "T_OPT", "T_APL", "T_UINFO", "T_UID", "T_GID", "T_UNSPEC", "T_TKEY",
  "T_TSIG", "T_IXFR", "T_AXFR", "T_MAILB", "T_MAILA", "T_DS", "T_DLV",
  "T_SSHFP", "T_RRSIG", "T_NSEC", "T_DNSKEY", "T_SPF", "T_NSEC3",
  "T_IPSECKEY", "T_DHCID", "T_NSEC3PARAM", "T_TLSA", "DOLLAR_TTL",
  "DOLLAR_ORIGIN", "NL", "SP", "NO_MEM", "STR", "PREV", "BITLAB", "T_TTL",
  "T_RRCLASS", "URR", "T_UTYPE", "'.'", "'@'", "$accept", "lines", "line",
  "sp", "trail", "ttl_directive", "origin_directive", "rr", "owner",
  "classttl", "dname", "abs_dname", "label", "rel_dname", "wire_dname",
  "wire_abs_dname", "wire_label", "wire_rel_dname", "str_seq",
  "concatenated_str_seq", "nxt_seq", "nsec_more", "nsec_seq", "str_sp_seq",
  "str_dot_seq", "dotted_str", "type_and_rdata", "rdata_a",
  "rdata_domain_name", "rdata_soa", "rdata_wks", "rdata_hinfo",
  "rdata_minfo", "rdata_mx", "rdata_txt", "rdata_rp", "rdata_afsdb",
  "rdata_x25", "rdata_isdn", "rdata_rt", "rdata_nsap", "rdata_px",
  "rdata_aaaa", "rdata_loc", "rdata_nxt", "rdata_srv", "rdata_naptr",
  "rdata_kx", "rdata_cert", "rdata_apl", "rdata_apl_seq", "rdata_ds",
  "rdata_dlv", "rdata_sshfp", "rdata_dhcid", "rdata_rrsig", "rdata_nsec",
  "rdata_nsec3", "rdata_nsec3_param", "rdata_tlsa", "rdata_dnskey",
  "rdata_ipsec_base", "rdata_ipseckey", "rdata_unknown", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    46,
      64
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    81,    82,    82,    83,    83,    83,    83,    83,    83,
      83,    83,    84,    84,    85,    85,    86,    87,    87,    88,
      89,    89,    90,    90,    90,    90,    90,    91,    91,    92,
      92,    92,    93,    93,    94,    94,    95,    95,    96,    96,
      97,    98,    98,    99,    99,   100,   100,   100,   100,   101,
     101,   102,   102,   102,   103,   103,   104,   104,   105,   105,
     106,   106,   106,   106,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   143,   144,   144,   144
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     1,     2,     1,     2,     1,     1,
       1,     2,     1,     2,     1,     2,     4,     4,     4,     3,
       2,     1,     0,     2,     2,     4,     4,     1,     1,     1,
       1,     2,     1,     1,     1,     3,     1,     1,     1,     2,
       1,     1,     3,     1,     3,     1,     1,     3,     3,     1,
       3,     2,     1,     2,     1,     2,     1,     3,     1,     3,
       1,     1,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     1,     2,     2,
      14,     6,     4,     4,     4,     2,     4,     4,     2,     2,
       4,     4,     2,     6,     2,     2,     4,     8,    12,     4,
       8,     2,     1,     3,     8,     8,     6,     2,    18,     2,
      10,     8,     8,     8,     7,     4,     2,     6,     4,     3
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,     0,     0,     0,     4,    12,     6,    32,
      21,    33,    29,    30,     3,     0,     8,     9,    10,    22,
       0,    27,    34,    28,    11,     0,     0,     7,     5,    13,
       0,     0,     0,    20,    31,     0,     0,     0,    24,    23,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   157,     0,     0,    19,    35,
      14,     0,    16,    17,    18,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     134,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    15,    25,    26,    60,     0,
      61,     0,    64,    65,     0,    66,    67,     0,    90,    91,
      43,     0,    92,    93,    72,    73,     0,   118,   119,    84,
      85,     0,   122,   123,     0,   114,   115,     0,    74,    75,
       0,   112,   113,     0,   124,   125,     0,   130,   131,    45,
      46,     0,   120,   121,    68,    69,    70,    71,    76,    77,
      78,    79,    80,    81,     0,    82,    83,     0,    86,    87,
       0,    88,    89,     0,    96,    97,     0,    98,    99,     0,
     100,   101,     0,   102,   103,     0,   108,   109,    58,     0,
     110,   111,     0,   116,   117,     0,   126,   127,     0,   128,
     129,   132,   133,   182,   135,     0,   136,     0,   137,   138,
       0,   139,   140,     0,   141,   142,   143,   144,    40,    38,
       0,    36,    41,    37,   145,   146,   153,   154,    94,    95,
       0,   147,   148,     0,     0,   104,   105,    56,     0,   106,
     107,     0,   149,   150,     0,   151,   152,   156,   155,     0,
       0,    62,   158,   159,     0,     0,   165,   174,     0,     0,
       0,     0,     0,     0,     0,     0,   175,     0,     0,     0,
       0,     0,   168,     0,   169,     0,     0,   172,     0,     0,
       0,     0,   181,     0,     0,     0,    54,     0,   189,    39,
       0,     0,     0,   196,     0,   187,     0,     0,   199,     0,
      63,     0,    44,    49,     0,     0,     0,     0,     0,     0,
      48,    47,     0,     0,     0,     0,     0,     0,     0,    59,
       0,     0,     0,   183,     0,     0,     0,    52,     0,     0,
      55,    42,     0,     0,     0,    57,     0,     0,     0,   198,
     164,     0,   176,     0,     0,     0,     0,     0,     0,   162,
     163,   166,   167,   170,   171,     0,     0,   179,     0,     0,
       0,    51,    53,     0,     0,   195,     0,     0,     0,    50,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   197,     0,     0,     0,     0,
       0,   161,   173,     0,     0,     0,   186,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     194,     0,     0,   193,     0,     0,   177,   180,     0,   184,
     185,     0,   191,   192,     0,     0,     0,     0,     0,     0,
       0,   190,     0,     0,     0,     0,     0,   178,     0,     0,
     160,     0,     0,     0,     0,   188
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    14,    91,    92,    16,    17,    18,    19,    32,
     154,    21,    22,    23,   260,   261,   262,   263,   161,   191,
     344,   370,   328,   278,   229,   151,    88,   152,   155,   178,
     205,   208,   211,   158,   162,   214,   217,   220,   223,   226,
     230,   233,   167,   192,   172,   184,   236,   239,   187,   244,
     245,   248,   251,   254,   279,   181,   264,   271,   282,   285,
     175,   274,   275,   153
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -368
static const yytype_int16 yypact[] =
{
    -368,   188,  -368,   -64,   -35,   -35,  -368,  -368,  -368,  -368,
      16,  -368,  -368,  -368,  -368,    85,  -368,  -368,  -368,   203,
     -35,  -368,  -368,    17,  -368,   114,   -62,  -368,  -368,  -368,
     -35,   -35,   759,    29,   136,   129,   129,   -43,    98,    83,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   129,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,  -368,   120,   -35,  -368,  -368,
    -368,   221,  -368,  -368,  -368,   -35,   -35,   -63,    31,    37,
      74,    31,   -63,    31,    31,    75,    31,    89,    92,    95,
      55,    31,    31,    31,    31,    31,   -63,   123,    31,    31,
     124,   141,   150,   156,   166,   193,   194,   204,    31,    43,
    -368,   212,   215,   216,    89,    59,    75,    74,   225,   226,
     229,   235,   247,    94,    21,  -368,    29,    29,  -368,    14,
    -368,    23,  -368,  -368,   129,  -368,  -368,   -35,  -368,  -368,
    -368,   129,  -368,  -368,  -368,  -368,    23,  -368,  -368,  -368,
    -368,   -35,  -368,  -368,   -35,  -368,  -368,   -35,  -368,  -368,
     -35,  -368,  -368,   -35,  -368,  -368,   -35,  -368,  -368,  -368,
    -368,    47,  -368,  -368,  -368,  -368,  -368,  -368,  -368,  -368,
    -368,  -368,  -368,  -368,   -42,  -368,  -368,   -35,  -368,  -368,
     -35,  -368,  -368,   -35,  -368,  -368,   -35,  -368,  -368,   129,
    -368,  -368,   129,  -368,  -368,   -35,  -368,  -368,  -368,    54,
    -368,  -368,   -35,  -368,  -368,   -35,  -368,  -368,   -35,  -368,
    -368,  -368,  -368,    60,  -368,   129,  -368,   -35,  -368,  -368,
     -35,  -368,  -368,   -35,  -368,  -368,  -368,  -368,  -368,  -368,
     288,  -368,  -368,    96,  -368,  -368,  -368,  -368,  -368,  -368,
     -35,  -368,  -368,   -35,   129,  -368,  -368,  -368,   129,  -368,
    -368,   -35,  -368,  -368,   -35,  -368,  -368,  -368,  -368,   102,
     169,   109,  -368,  -368,   -62,   -38,  -368,  -368,   181,   256,
     -62,   257,   260,   261,   130,   108,  -368,   264,   265,   -62,
     -62,   -62,  -368,   135,  -368,   -62,   142,  -368,   -62,   269,
     -62,    18,  -368,   280,   283,   284,  -368,   147,  -368,   151,
     296,   297,   160,  -368,   178,  -368,   307,   308,  -368,   129,
    -368,   129,  -368,  -368,   129,   -35,   -35,   -35,   -35,   -35,
    -368,  -368,   -35,   129,   129,   129,   129,   129,   129,  -368,
     -35,   -35,   129,    60,   -35,   -35,   -35,  -368,   147,   288,
    -368,  -368,   -35,   -35,   129,  -368,   -35,   -35,   160,  -368,
    -368,   253,  -368,   311,   312,   315,   316,   319,    58,  -368,
    -368,  -368,  -368,  -368,  -368,   -62,   320,  -368,   324,   327,
     328,  -368,  -368,   331,   332,  -368,   336,   354,   129,  -368,
     -35,   -35,   -35,   -35,   -35,    47,   129,   -35,   -35,   -35,
     129,   -35,   -35,   -35,   -35,  -368,   328,   355,   360,   -62,
     328,  -368,  -368,   363,   328,   328,  -368,   364,    70,   367,
     328,   129,   -35,   -35,   129,   129,   -35,   129,   129,   -35,
      60,   129,   129,  -368,   380,   383,  -368,  -368,   384,  -368,
    -368,   387,  -368,  -368,   -35,   -35,   -35,   288,   388,   397,
     -62,  -368,   -35,   -35,   129,   403,   404,  -368,   129,   -35,
    -368,    71,   -35,   328,   129,  -368
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -368,  -368,  -368,    -1,   277,  -368,  -368,  -368,  -368,  -368,
       0,   209,   208,   219,  -227,  -368,   -54,  -368,  -368,   -84,
    -368,   -60,  -367,  -243,  -368,   -96,  -368,  -368,   -90,  -368,
    -368,  -368,  -368,  -368,   179,  -368,  -368,  -368,  -368,  -368,
    -368,  -368,  -368,  -368,  -368,  -368,  -368,  -368,  -368,  -368,
    -368,  -368,  -368,  -368,  -368,   187,  -368,  -368,  -368,  -368,
     234,  -368,  -368,   458
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
      15,    20,   402,    25,    26,    24,   166,    29,    29,   148,
       9,   164,    11,   169,   149,   289,   150,    12,    13,    33,
     204,   194,   196,   198,   200,   202,    90,     7,     7,    38,
      39,   145,    29,   243,   342,     7,    34,   291,   241,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,     7,    27,   144,   145,    29,   374,
     148,    29,    90,     7,   146,   147,    34,   150,   149,    29,
     471,    29,   291,     9,   171,    11,   177,    29,   149,   157,
      12,    13,   145,    29,   149,   148,    90,     7,   210,   213,
     149,   143,   150,    90,     7,    29,   304,   189,    29,    29,
     189,   258,   149,   316,   190,   408,   149,   190,   259,   291,
      29,    29,   148,   258,    29,    29,   160,   174,   290,   150,
     259,   149,   149,    29,    28,    29,   294,   420,    96,    29,
     295,   180,    29,   287,   183,    29,   149,   186,    29,   149,
     298,   338,   149,   299,    95,   329,   300,   145,    29,   301,
     351,   340,   302,   441,    29,   303,    35,   445,     2,     3,
     305,   447,   448,    29,    29,   207,   216,   452,    90,     7,
     149,   149,   350,   307,   145,    29,   308,   357,     9,   309,
      11,    29,   310,   219,   359,   311,   367,   368,   149,   369,
      29,   313,   222,   258,   315,   363,    29,   149,   225,   145,
      29,   318,   277,   149,   319,    36,    29,   320,   228,    29,
     484,   339,    89,   149,   321,    37,   323,   145,    29,   324,
     375,    29,   325,   343,   482,     4,     5,     6,     7,     8,
       9,    10,    11,    29,    29,   232,   235,    12,    13,   330,
     149,   149,   331,   332,    29,   371,   238,   334,    30,    31,
     336,   149,    29,   337,   247,    29,    29,   250,   253,   149,
     145,    29,   149,   149,   341,    29,    29,   270,   273,    29,
     346,   277,   149,   149,   415,    29,   149,   281,   401,   354,
     355,   356,   149,    93,    94,   358,   268,    29,   360,   284,
     362,   256,   145,    29,   149,   409,    29,    29,   345,   347,
      29,    29,   348,   349,    29,    29,   352,   353,   378,    29,
       0,   361,   450,   381,   383,   384,   385,   386,   387,   130,
      29,   388,   364,    29,    29,   365,   366,   326,   327,   395,
     396,     0,     0,   398,   399,   400,    29,    29,   372,   373,
     266,   403,   404,   334,     0,   406,   407,    29,    29,   376,
     377,    29,    29,   410,   411,    29,    29,   412,   413,    29,
      29,   414,   417,     0,    29,   416,   418,    29,    29,   419,
     277,    29,    29,   421,   422,     0,    29,   334,   423,   426,
     427,   428,   429,   430,   305,     0,   433,   434,   435,   334,
     437,   438,   439,   440,    29,    29,   424,   442,   292,   444,
      29,   293,   443,    29,    29,   446,   449,    29,   296,   451,
     334,   454,   455,   297,   334,   458,   334,   334,   461,     0,
      29,   334,   464,    29,    29,   465,   466,    29,    29,   467,
     472,     0,     0,   468,   469,   470,     0,    29,   306,   473,
     474,   475,   476,    29,    29,   478,   479,     0,   481,     0,
       0,   483,     0,   334,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   312,     0,     0,   314,
       0,     0,     0,     0,     0,     0,   317,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   322,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   333,     0,     0,     0,   335,   156,   159,   163,   165,
     168,   170,   173,   176,   179,   182,   185,   188,   193,   195,
     197,   199,   201,   203,   206,   209,   212,   215,   218,   221,
     224,   227,   231,   234,   237,   240,   242,   246,     0,   249,
     252,   255,   257,   265,   267,   269,   272,   276,   280,   283,
     286,     0,   288,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   379,     0,   380,     0,
       0,   382,     0,     0,     0,     0,     0,     0,     0,     0,
     389,   390,   391,   392,   393,   394,     0,     0,     0,   397,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   405,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   425,     0,     0,     0,     0,
       0,     0,   431,   432,     0,     0,     0,   436,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   453,     0,
       0,   456,   457,     0,   459,   460,     0,     0,   462,   463,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   477,     0,     0,     0,   480,     0,     0,     0,     0,
       0,   485,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,     0,    59,    60,    61,    62,    63,    64,    65,    66,
      67,     0,    68,     0,     0,     0,     0,    69,    70,     0,
      71,     0,     0,    72,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,     0,     0,     0,     0,
      85,    86,     0,     0,     0,     0,     0,    87
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-368))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       1,     1,   369,     4,     5,    69,   102,    70,    70,    72,
      72,   101,    74,   103,    77,     1,    79,    79,    80,    20,
     116,   111,   112,   113,   114,   115,    69,    70,    70,    30,
      31,    69,    70,   129,    72,    70,    79,    79,   128,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    70,    69,    87,    69,    70,   332,
      72,    70,    69,    70,    95,    96,    79,    79,    77,    70,
     467,    70,    79,    72,   104,    74,   106,    70,    77,    72,
      79,    80,    69,    70,    77,    72,    69,    70,   118,   119,
      77,     1,    79,    69,    70,    70,    79,    72,    70,    70,
      72,    72,    77,    79,    79,   378,    77,    79,    79,    79,
      70,    70,    72,    72,    70,    70,    72,    72,   149,    79,
      79,    77,    77,    70,    69,    70,   157,   400,    75,    70,
     161,    72,    70,    69,    72,    70,    77,    72,    70,    77,
     171,    69,    77,   174,    76,    79,   177,    69,    70,   180,
      72,    72,   183,   426,    70,   186,    72,   430,     0,     1,
     191,   434,   435,    70,    70,    72,    72,   440,    69,    70,
      77,    77,    72,   204,    69,    70,   207,    72,    72,   210,
      74,    70,   213,    72,    72,   216,    69,    70,    77,    72,
      70,   222,    72,    72,   225,   321,    70,    77,    72,    69,
      70,   232,    72,    77,   235,    26,    70,   238,    72,    70,
     483,    72,    34,    77,   245,    26,   247,    69,    70,   250,
      72,    70,   253,    72,   481,    67,    68,    69,    70,    71,
      72,    73,    74,    70,    70,    72,    72,    79,    80,   270,
      77,    77,   273,   274,    70,   329,    72,   278,    75,    76,
     281,    77,    70,   284,    72,    70,    70,    72,    72,    77,
      69,    70,    77,    77,   294,    70,    70,    72,    72,    70,
     300,    72,    77,    77,   388,    70,    77,    72,   368,   309,
     310,   311,    77,    36,    37,   315,   137,    70,   318,    72,
     320,   134,    69,    70,    77,    72,    70,    70,    72,    72,
      70,    70,    72,    72,    70,    70,    72,    72,   339,    70,
      -1,    72,   438,   344,   345,   346,   347,   348,   349,    72,
      70,   352,    72,    70,    70,    72,    72,    69,    70,   360,
     361,    -1,    -1,   364,   365,   366,    70,    70,    72,    72,
     136,   372,   373,   374,    -1,   376,   377,    70,    70,    72,
      72,    70,    70,    72,    72,    70,    70,    72,    72,    70,
      70,    72,    72,    -1,    70,   395,    72,    70,    70,    72,
      72,    70,    70,    72,    72,    -1,    70,   408,    72,   410,
     411,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,    70,    70,    72,    72,   151,   429,
      70,   154,    72,    70,    70,    72,    72,    70,   161,    72,
     441,   442,   443,   166,   445,   446,   447,   448,   449,    -1,
      70,   452,    72,    70,    70,    72,    72,    70,    70,    72,
      72,    -1,    -1,   464,   465,   466,    -1,    70,   191,    72,
     470,   472,   473,    70,    70,    72,    72,    -1,   479,    -1,
      -1,   482,    -1,   484,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   219,    -1,    -1,   222,
      -1,    -1,    -1,    -1,    -1,    -1,   229,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   274,    -1,    -1,    -1,   278,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,    -1,   144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,   341,    -1,
      -1,   344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     353,   354,   355,   356,   357,   358,    -1,    -1,    -1,   362,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   374,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   408,    -1,    -1,    -1,    -1,
      -1,    -1,   415,   416,    -1,    -1,    -1,   420,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   441,    -1,
      -1,   444,   445,    -1,   447,   448,    -1,    -1,   451,   452,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   474,    -1,    -1,    -1,   478,    -1,    -1,    -1,    -1,
      -1,   484,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    33,    -1,    -1,    -1,    -1,    38,    39,    -1,
      41,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    -1,    -1,    -1,    -1,
      71,    72,    -1,    -1,    -1,    -1,    -1,    78
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    82,     0,     1,    67,    68,    69,    70,    71,    72,
      73,    74,    79,    80,    83,    84,    86,    87,    88,    89,
      91,    92,    93,    94,    69,    84,    84,    69,    69,    70,
      75,    76,    90,    84,    79,    72,    92,    94,    84,    84,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    33,    38,
      39,    41,    44,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    71,    72,    78,   107,    93,
      69,    84,    85,    85,    85,    76,    75,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      85,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,     1,    84,    69,    84,    84,    72,    77,
      79,   106,   108,   144,    91,   109,   144,    72,   114,   144,
      72,    99,   115,   144,   109,   144,   106,   123,   144,   109,
     144,    91,   125,   144,    72,   141,   144,    91,   110,   144,
      72,   136,   144,    72,   126,   144,    72,   129,   144,    72,
      79,   100,   124,   144,   109,   144,   109,   144,   109,   144,
     109,   144,   109,   144,   106,   111,   144,    72,   112,   144,
      91,   113,   144,    91,   116,   144,    72,   117,   144,    72,
     118,   144,    72,   119,   144,    72,   120,   144,    72,   105,
     121,   144,    72,   122,   144,    72,   127,   144,    72,   128,
     144,   109,   144,   106,   130,   131,   144,    72,   132,   144,
      72,   133,   144,    72,   134,   144,   136,   144,    72,    79,
      95,    96,    97,    98,   137,   144,   141,   144,   115,   144,
      72,   138,   144,    72,   142,   143,   144,    72,   104,   135,
     144,    72,   139,   144,    72,   140,   144,    69,   144,     1,
      84,    79,    85,    85,    84,    84,    85,    85,    84,    84,
      84,    84,    84,    84,    79,    84,    85,    84,    84,    84,
      84,    84,    85,    84,    85,    84,    79,    85,    84,    84,
      84,    84,    85,    84,    84,    84,    69,    70,   103,    79,
      84,    84,    84,    85,    84,    85,    84,    84,    69,    72,
      72,    91,    72,    72,   101,    72,    91,    72,    72,    72,
      72,    72,    72,    72,    91,    91,    91,    72,    91,    72,
      91,    72,    91,   106,    72,    72,    72,    69,    70,    72,
     102,    97,    72,    72,   104,    72,    72,    72,    84,    85,
      85,    84,    85,    84,    84,    84,    84,    84,    84,    85,
      85,    85,    85,    85,    85,    84,    84,    85,    84,    84,
      84,   102,   103,    84,    84,    85,    84,    84,   104,    72,
      72,    72,    72,    72,    72,   100,    91,    72,    72,    72,
     104,    72,    72,    72,    72,    85,    84,    84,    84,    84,
      84,    85,    85,    84,    84,    84,    85,    84,    84,    84,
      84,   104,    72,    72,    91,   104,    72,   104,   104,    72,
     106,    72,   104,    85,    84,    84,    85,    85,    84,    85,
      85,    84,    85,    85,    72,    72,    72,    72,    84,    84,
      84,   103,    72,    72,    91,    84,    84,    85,    72,    72,
      85,    84,    95,    84,   104,    85
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (scanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, scanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, scanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, void *scanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, scanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    void *scanner;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (scanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, void *scanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, scanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    void *scanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, scanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule, void *scanner)
#else
static void
yy_reduce_print (yyvsp, yyrule, scanner)
    YYSTYPE *yyvsp;
    int yyrule;
    void *scanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       , scanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule, scanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, void *scanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, scanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    void *scanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (scanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void *scanner);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *scanner)
#else
int
yyparse (scanner)
    void *scanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:

/* Line 1806 of yacc.c  */
#line 156 "zparser.y"
    {
    		zc_error_prev_line("Parser ran out of memory!");
		YYABORT;
	}
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 160 "zparser.y"
    {}
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 162 "zparser.y"
    {
	    parser->error_occurred = 0;
    }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 166 "zparser.y"
    {
	    parser->error_occurred = 0;
    }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 170 "zparser.y"
    {	/* rr should be fully parsed */
	if (!parser->error_occurred) {
		/*!< \todo assign error to error occurred */
		/*! \todo Make sure this does not crash */
		if (parser->current_rrset->owner == NULL) {
			knot_rrset_deep_free(&(parser->current_rrset),
					       0, 0, 0);
			knot_zone_deep_free(&(parser->current_zone),
					      1);
			YYABORT;
		}
		knot_rdata_t *tmp_rdata = knot_rdata_new();
		if (tmp_rdata == NULL) {
			knot_rrset_deep_free(&(parser->current_rrset),
					       0, 0, 0);
			knot_zone_deep_free(&(parser->current_zone),
					      1);
			YYABORT;
		}

		if (knot_rdata_set_items(tmp_rdata,
		    parser->temporary_items,
		    parser->rdata_count) != 0) {
			knot_rdata_free(&tmp_rdata);
			knot_rrset_deep_free(&(parser->current_rrset), 0, 0, 0);
			knot_zone_deep_free(&(parser->current_zone), 1);
			YYABORT;
		}

		assert(parser->current_rrset->rdata == NULL);
		if (knot_rrset_add_rdata(parser->current_rrset, tmp_rdata)
		    != 0) {
		    	log_zone_error("Could not add rdata!\n");
		    }
//		tmp_rdata->next = tmp_rdata;
//		parser->current_rrset->rdata = tmp_rdata;

		if (!knot_dname_is_fqdn(parser->current_rrset->owner)) {
			knot_dname_t *tmp_dname =
				knot_dname_cat(parser->current_rrset->owner,
						 parser->root_domain);
			if (tmp_dname == NULL) {
				knot_rrset_deep_free(&(parser->current_rrset),
				                       0, 0, 0);
				knot_zone_deep_free(&(parser->current_zone),
				                      1);
				YYABORT;
			}
//			knot_rrset_set_owner(parser->current_rrset, tmp_dname);
		}

		assert(parser->current_rrset->owner != NULL);
		knot_dname_retain(parser->current_rrset->owner);
		int ret = 0;
		if ((ret = process_rr()) != 0) {
			char *name =
				knot_dname_to_str(parser->current_rrset->owner);
			log_zone_error("Error: could not process RRSet\n"
				"owner: %s reason: %s\n",
				name,
				error_to_str(knot_zcompile_error_msgs, ret));
			free(name);

			/* If the owner is not already in the table, free it. */
//			if (dnslib_dname_table_find_dname(parser->dname_table,
//				parser->current_rrset->owner) == NULL) {
//				dnslib_dname_free(&parser->
//				                  current_rrset->owner);
//			} /* This would never happen */

			if (ret == KNOTDZCOMPILE_EBADSOA) {
				knot_rrset_deep_free(&(parser->current_rrset),
						       0, 0, 0);
				knot_zone_deep_free(&(parser->current_zone),
						      1);
				YYABORT;
			} else {
				YYABORT;
				/* Free rdata, it will not be added
				 * and hence cannot be
				 * freed with rest of the zone. */
/*				knot_rdata_deep_free(&tmp_rdata,
				                       parser->
				                       current_rrset->type,
				                       0); */
			}
		}
	} else {
		/* Error occured. This could either be lack of memory, or one
		 * of the converting function was not able to convert. */
		if (parser->error_occurred == KNOTDZCOMPILE_ENOMEM) {
			/* Ran out of memory in converting functions. */
			log_zone_error("Parser ran out "
			                "of memory, aborting!\n");
			knot_rrset_deep_free(&(parser->current_rrset),
					       0, 0, 0);
			knot_zone_deep_free(&(parser->current_zone),
					      1);
			YYABORT;
		}
	}

//	printf("Current rrset name: %p (%s)\n", parser->current_rrset->owner->name,
//	knot_dname_to_str(parser->current_rrset->owner));

//	knot_dname_release(parser->current_rrset->owner);

	    parser->current_rrset->type = 0;
	    parser->rdata_count = 0;
	    parser->current_rrset->rdata = NULL;
	    parser->error_occurred = 0;
    }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 295 "zparser.y"
    {
	parser->default_ttl = zparser_ttl2int((yyvsp[(3) - (4)].data).str,
					      &(parser->error_occurred));
	if (parser->error_occurred == 1) {
		parser->default_ttl = DEFAULT_TTL;
		parser->error_occurred = 0;
	}

	free((yyvsp[(3) - (4)].data).str);
    }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 310 "zparser.y"
    {
    /*!< \todo this will leak. */
	    knot_node_t *origin_node = knot_node_new((yyvsp[(3) - (4)].domain) ,NULL, 0);
	if (parser->origin != NULL) {
//		knot_node_free(&parser->origin, 1);
	}
	    parser->origin = origin_node;
    }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 319 "zparser.y"
    {
	    zc_error_prev_line("$ORIGIN directive requires"
			       "absolute domain name");
    }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 326 "zparser.y"
    {
	    /* Save the pointer, it might get freed! */
	    parser->current_rrset->owner = (yyvsp[(1) - (3)].domain);
//	    parser->current_rrset->owner = $1;
//	    printf("new owner assigned: %p\n", $1);
	    parser->current_rrset->type = (yyvsp[(3) - (3)].type);
    }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 336 "zparser.y"
    {
//    	char *name = knot_dname_to_str($1);
//	printf("Totally new dname: %p %s\n", $1,
//	name);
//	free(name);
	if (parser->prev_dname != NULL) {
	//	knot_dname_release(parser->prev_dname);
	}
	parser->prev_dname = (yyvsp[(1) - (2)].domain);//knot_dname_deep_copy($1);
	knot_dname_retain(parser->prev_dname);
	(yyval.domain) = (yyvsp[(1) - (2)].domain);
    }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 349 "zparser.y"
    {
//	    printf("Name from prev_dname!: %p %s\n", parser->prev_dname,
//	    knot_dname_to_str(parser->prev_dname));
	    knot_dname_retain(parser->prev_dname);
	    (yyval.domain) = parser->prev_dname;//knot_dname_deep_copy(parser->prev_dname);
    }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 358 "zparser.y"
    {
	    parser->current_rrset->ttl = parser->default_ttl;
	    parser->current_rrset->rclass = parser->default_class;
    }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 363 "zparser.y"
    {
	    parser->current_rrset->ttl = parser->default_ttl;
	    parser->current_rrset->rclass = (yyvsp[(1) - (2)].rclass);
    }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 368 "zparser.y"
    {
	    parser->current_rrset->ttl = (yyvsp[(1) - (2)].ttl);
	    parser->current_rrset->rclass = parser->default_class;
    }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 373 "zparser.y"
    {
	    parser->current_rrset->ttl = (yyvsp[(1) - (4)].ttl);
	    parser->current_rrset->rclass = (yyvsp[(3) - (4)].rclass);
    }
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 378 "zparser.y"
    {
	    parser->current_rrset->ttl = (yyvsp[(3) - (4)].ttl);
	    parser->current_rrset->rclass = (yyvsp[(1) - (4)].rclass);
    }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 386 "zparser.y"
    {
	    if ((yyvsp[(1) - (1)].dname) == error_dname) {
		    (yyval.domain) = error_domain;
	    } else if ((yyvsp[(1) - (1)].dname)->size + parser->origin->owner->size - 1 >
		       MAXDOMAINLEN) {
		    zc_error("domain name exceeds %d character limit",
			     MAXDOMAINLEN);
		    (yyval.domain) = error_domain;
	    } else {
		    (yyval.domain) = knot_dname_cat((yyvsp[(1) - (1)].dname),
					  parser->origin->owner);
	    }
    }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 402 "zparser.y"
    {
	    (yyval.domain) = parser->root_domain;
	    /* TODO how about concatenation now? */
    }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 407 "zparser.y"
    {
    	assert(parser->origin != NULL);
	(yyval.domain) = parser->origin->owner;
    }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 412 "zparser.y"
    {
	    if ((yyvsp[(1) - (2)].dname) != error_dname) {
		    (yyval.domain) = (yyvsp[(1) - (2)].dname);
	    } else {
		    (yyval.domain) = error_domain;
	    }
    }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 422 "zparser.y"
    {
	    if ((yyvsp[(1) - (1)].data).len > MAXLABELLEN) {
		    zc_error("label exceeds %d character limit", MAXLABELLEN);
		    (yyval.dname) = error_dname;
	    } else {
		    (yyval.dname) = knot_dname_new_from_str((yyvsp[(1) - (1)].data).str, (yyvsp[(1) - (1)].data).len, NULL);
	(yyval.dname)->ref.count = 0;
	    }

	    free((yyvsp[(1) - (1)].data).str);

    }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 435 "zparser.y"
    {
	    zc_error("bitlabels are not supported."
		     "RFC2673 has status experimental.");
	    (yyval.dname) = error_dname;
    }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 444 "zparser.y"
    {
	    if ((yyvsp[(1) - (3)].dname) == error_dname || (yyvsp[(3) - (3)].dname) == error_dname) {
		    (yyval.dname) = error_dname;
	    } else if ((yyvsp[(1) - (3)].dname)->size + (yyvsp[(3) - (3)].dname)->size - 1 > MAXDOMAINLEN) {
		    zc_error("domain name exceeds %d character limit",
			     MAXDOMAINLEN);
		    (yyval.dname) = error_dname;
	    } else {
		    (yyval.dname) = knot_dname_cat((yyvsp[(1) - (3)].dname), (yyvsp[(3) - (3)].dname));
//		    knot_dname_release($1); /*!< \todo check! */
		    knot_dname_free(&(yyvsp[(3) - (3)].dname));
		}
    }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 468 "zparser.y"
    {
	    char *result = malloc(2 * sizeof(char));
	    if (result == NULL) {
	    	ERR_ALLOC_FAILED;
	    	knot_rrset_deep_free(&(parser->current_rrset),
		                       0, 0, 0);
	        knot_zone_deep_free(&(parser->current_zone),
		                      1);
		YYABORT;
	    }
	    result[0] = 0;
	    result[1] = '\0';
	    (yyval.data).str = result;
	    (yyval.data).len = 1;
    }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 484 "zparser.y"
    {
	    char *result = malloc((yyvsp[(1) - (2)].data).len + 2 * sizeof(char));
	    if (result == NULL) {
	    	ERR_ALLOC_FAILED;
	    	knot_rrset_deep_free(&(parser->current_rrset),
		                       0, 0, 0);
	        knot_zone_deep_free(&(parser->current_zone),
		                      1);
		YYABORT;
	    }
	    memcpy(result, (yyvsp[(1) - (2)].data).str, (yyvsp[(1) - (2)].data).len);
	    result[(yyvsp[(1) - (2)].data).len] = 0;
	    result[(yyvsp[(1) - (2)].data).len+1] = '\0';
	    (yyval.data).str = result;
	    (yyval.data).len = (yyvsp[(1) - (2)].data).len + 1;

	    free((yyvsp[(1) - (2)].data).str);
;
    }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 506 "zparser.y"
    {
	    char *result = malloc((yyvsp[(1) - (1)].data).len + sizeof(char));
	    if (result == NULL) {
	    	ERR_ALLOC_FAILED;
	    	knot_rrset_deep_free(&(parser->current_rrset),
		                       0, 0, 0);
	        knot_zone_deep_free(&(parser->current_zone),
		                      1);
		YYABORT;
	    }

	    if ((yyvsp[(1) - (1)].data).len > MAXLABELLEN)
		    zc_error("label exceeds %d character limit", MAXLABELLEN);

	    /* make label anyway */
	    result[0] = (yyvsp[(1) - (1)].data).len;
	    memcpy(result+1, (yyvsp[(1) - (1)].data).str, (yyvsp[(1) - (1)].data).len);

	    (yyval.data).str = result;
	    (yyval.data).len = (yyvsp[(1) - (1)].data).len + 1;

	    free((yyvsp[(1) - (1)].data).str);
    }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 533 "zparser.y"
    {
	    if ((yyvsp[(1) - (3)].data).len + (yyvsp[(3) - (3)].data).len - 3 > MAXDOMAINLEN)
		    zc_error("domain name exceeds %d character limit",
			     MAXDOMAINLEN);

	    /* make dname anyway */
	    (yyval.data).len = (yyvsp[(1) - (3)].data).len + (yyvsp[(3) - (3)].data).len;
	    (yyval.data).str = malloc((yyval.data).len + sizeof(char));
	    if ((yyval.data).str == NULL) {
	    	ERR_ALLOC_FAILED;
	    	knot_rrset_deep_free(&(parser->current_rrset),
		                       0, 0, 0);
		knot_zone_deep_free(&(parser->current_zone),
		                      1);
		YYABORT;
	    }
	    memcpy((yyval.data).str, (yyvsp[(1) - (3)].data).str, (yyvsp[(1) - (3)].data).len);
	    memcpy((yyval.data).str + (yyvsp[(1) - (3)].data).len, (yyvsp[(3) - (3)].data).str, (yyvsp[(3) - (3)].data).len);
	    (yyval.data).str[(yyval.data).len] = '\0';

	    free((yyvsp[(1) - (3)].data).str);
	    free((yyvsp[(3) - (3)].data).str);
    }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 561 "zparser.y"
    {
	    zadd_rdata_txt_wireformat(zparser_conv_text((yyvsp[(1) - (1)].data).str, (yyvsp[(1) - (1)].data).len), 1);

	    if(strcmp((yyvsp[(1) - (1)].data).str, ".") && strcmp((yyvsp[(1) - (1)].data).str, "@")
                && strcmp((yyvsp[(1) - (1)].data).str, "\\#")) {		// Lexer freed that
	    	free((yyvsp[(1) - (1)].data).str);
            }
    }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 570 "zparser.y"
    {
	    zadd_rdata_txt_wireformat(zparser_conv_text((yyvsp[(3) - (3)].data).str, (yyvsp[(3) - (3)].data).len), 0);

	    if(strcmp((yyvsp[(3) - (3)].data).str, ".") && strcmp((yyvsp[(3) - (3)].data).str, "@")
                && strcmp((yyvsp[(3) - (3)].data).str, "\\#")) {		// Lexer freed that
	    	free((yyvsp[(3) - (3)].data).str);
            }
    }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 586 "zparser.y"
    {
	    (yyval.data).len = 1;
	    (yyval.data).str = strdup(".");
    }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 591 "zparser.y"
    {
	    (yyval.data).len = (yyvsp[(1) - (3)].data).len + (yyvsp[(3) - (3)].data).len + 1;
	    (yyval.data).str = malloc((yyval.data).len + 1);
	    if ((yyval.data).str == NULL) {
	    	ERR_ALLOC_FAILED;
	    	knot_rrset_deep_free(&(parser->current_rrset),
		                       0, 0, 0);
	        knot_zone_deep_free(&(parser->current_zone),
		                      1);
		YYABORT;
	    }

	    memcpy((yyval.data).str, (yyvsp[(1) - (3)].data).str, (yyvsp[(1) - (3)].data).len);
	    memcpy((yyval.data).str + (yyvsp[(1) - (3)].data).len, " ", 1);
	    memcpy((yyval.data).str + (yyvsp[(1) - (3)].data).len + 1, (yyvsp[(3) - (3)].data).str, (yyvsp[(3) - (3)].data).len);
	    (yyval.data).str[(yyval.data).len] = '\0';

	    free((yyvsp[(1) - (3)].data).str);
	    free((yyvsp[(3) - (3)].data).str);
    }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 612 "zparser.y"
    {
	    (yyval.data).len = (yyvsp[(1) - (3)].data).len + (yyvsp[(3) - (3)].data).len + 1;
	    (yyval.data).str = malloc((yyval.data).len + 1);
	    if ((yyval.data).str == NULL) {
	    	ERR_ALLOC_FAILED;
	    	knot_rrset_deep_free(&(parser->current_rrset),
		                       0, 0, 0);
	        knot_zone_deep_free(&(parser->current_zone),
		                      1);
		YYABORT;
	    }
	    memcpy((yyval.data).str, (yyvsp[(1) - (3)].data).str, (yyvsp[(1) - (3)].data).len);
	    memcpy((yyval.data).str + (yyvsp[(1) - (3)].data).len, ".", 1);
	    memcpy((yyval.data).str + (yyvsp[(1) - (3)].data).len + 1, (yyvsp[(3) - (3)].data).str, (yyvsp[(3) - (3)].data).len);

	    free((yyvsp[(1) - (3)].data).str);
	    free((yyvsp[(3) - (3)].data).str);

	    (yyval.data).str[(yyval.data).len] = '\0';
    }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 636 "zparser.y"
    {
	    uint16_t type = knot_rrtype_from_string((yyvsp[(1) - (1)].data).str);
	    if (type != 0 && type < 128) {
		    set_bit(nxtbits, type);
	    } else {
		    zc_error("bad type %d in NXT record", (int) type);
	    }

	    free((yyvsp[(1) - (1)].data).str);
    }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 647 "zparser.y"
    {
	    uint16_t type = knot_rrtype_from_string((yyvsp[(3) - (3)].data).str);
	    if (type != 0 && type < 128) {
		    set_bit(nxtbits, type);
	    } else {
		    zc_error("bad type %d in NXT record", (int) type);
	    }

	    free((yyvsp[(3) - (3)].data).str);
    }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 660 "zparser.y"
    {
    }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 663 "zparser.y"
    {
    }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 666 "zparser.y"
    {
	    uint16_t type = knot_rrtype_from_string((yyvsp[(1) - (2)].data).str);
	    if (type != 0) {
		    if (type > nsec_highest_rcode) {
			    nsec_highest_rcode = type;
		    }
		    set_bitnsec(nsecbits, type);
	    } else {
		    zc_error("bad type %d in NSEC record", (int) type);
	    }

	    free((yyvsp[(1) - (2)].data).str);
    }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 691 "zparser.y"
    {
	    char *result = malloc((yyvsp[(1) - (3)].data).len + (yyvsp[(3) - (3)].data).len + 1);
	    if (result == NULL) {
	    	ERR_ALLOC_FAILED;
	    	log_zone_error("Parser ran out of memory, aborting!\n");
	    	knot_rrset_deep_free(&(parser->current_rrset),
		                       0, 0, 0);
	        knot_zone_deep_free(&(parser->current_zone),
		                      1);
		YYABORT;
	    }
	    memcpy(result, (yyvsp[(1) - (3)].data).str, (yyvsp[(1) - (3)].data).len);
	    memcpy(result + (yyvsp[(1) - (3)].data).len, (yyvsp[(3) - (3)].data).str, (yyvsp[(3) - (3)].data).len);
	    (yyval.data).str = result;
	    (yyval.data).len = (yyvsp[(1) - (3)].data).len + (yyvsp[(3) - (3)].data).len;
	    (yyval.data).str[(yyval.data).len] = '\0';

	    free((yyvsp[(1) - (3)].data).str);
	    free((yyvsp[(3) - (3)].data).str);
    }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 719 "zparser.y"
    {
	    char *result = malloc((yyvsp[(1) - (3)].data).len + (yyvsp[(3) - (3)].data).len + 1);
	    if (result == NULL) {
	    	ERR_ALLOC_FAILED;
	    	log_zone_error("Parser ran out of memory, aborting!\n");
	    	knot_rrset_deep_free(&(parser->current_rrset),
		                       0, 0, 0);
	        knot_zone_deep_free(&(parser->current_zone),
		                      1);
		YYABORT;
	    }
	    memcpy(result, (yyvsp[(1) - (3)].data).str, (yyvsp[(1) - (3)].data).len);
	    memcpy(result + (yyvsp[(1) - (3)].data).len, (yyvsp[(3) - (3)].data).str, (yyvsp[(3) - (3)].data).len);
	    (yyval.data).str = result;
	    (yyval.data).len = (yyvsp[(1) - (3)].data).len + (yyvsp[(3) - (3)].data).len;
	    (yyval.data).str[(yyval.data).len] = '\0';

	    free((yyvsp[(1) - (3)].data).str);
	    free((yyvsp[(3) - (3)].data).str);
    }
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 746 "zparser.y"
    {
	(yyval.data).str = ".";
	(yyval.data).len = 1;
    }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 751 "zparser.y"
    {
	    char *result = malloc((yyvsp[(1) - (2)].data).len + 2);
	    if (result == NULL) {
	    	ERR_ALLOC_FAILED;
	    	log_zone_error("Parser ran out of memory, aborting!\n");
	    	knot_rrset_deep_free(&(parser->current_rrset),
		                       0, 0, 0);
	        knot_zone_deep_free(&(parser->current_zone),
		                      1);
		YYABORT;
	    }
	    memcpy(result, (yyvsp[(1) - (2)].data).str, (yyvsp[(1) - (2)].data).len);
	    result[(yyvsp[(1) - (2)].data).len] = '.';
	    (yyval.data).str = result;
	    (yyval.data).len = (yyvsp[(1) - (2)].data).len + 1;
	    (yyval.data).str[(yyval.data).len] = '\0';

	    free((yyvsp[(1) - (2)].data).str);
    }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 771 "zparser.y"
    {
	    char *result = malloc((yyvsp[(1) - (3)].data).len + (yyvsp[(3) - (3)].data).len + 2);
	    if (result == NULL) {
	    	ERR_ALLOC_FAILED;
	    	log_zone_error("Parser ran out of memory, aborting!\n");
	    	knot_rrset_deep_free(&(parser->current_rrset),
		                       0, 0, 0);
	        knot_zone_deep_free(&(parser->current_zone),
		                      1);
		YYABORT;
	    }
	    memcpy(result, (yyvsp[(1) - (3)].data).str, (yyvsp[(1) - (3)].data).len);
	    result[(yyvsp[(1) - (3)].data).len] = '.';
	    memcpy(result + (yyvsp[(1) - (3)].data).len + 1, (yyvsp[(3) - (3)].data).str, (yyvsp[(3) - (3)].data).len);
	    (yyval.data).str = result;
	    (yyval.data).len = (yyvsp[(1) - (3)].data).len + (yyvsp[(3) - (3)].data).len + 1;
	    (yyval.data).str[(yyval.data).len] = '\0';


	    free((yyvsp[(1) - (3)].data).str);
	    free((yyvsp[(3) - (3)].data).str);
    }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 801 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 803 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 804 "zparser.y"
    { zc_warning_prev_line("MD is obsolete"); }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 806 "zparser.y"
    {
	    zc_warning_prev_line("MD is obsolete");
	    (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown));
    }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 810 "zparser.y"
    { zc_warning_prev_line("MF is obsolete"); }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 812 "zparser.y"
    {
	    zc_warning_prev_line("MF is obsolete");
	    (yyval.type) = (yyvsp[(1) - (3)].type);
	    parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown));
    }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 818 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 820 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 821 "zparser.y"
    { zc_warning_prev_line("MB is obsolete"); }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 823 "zparser.y"
    {
	    zc_warning_prev_line("MB is obsolete");
	    (yyval.type) = (yyvsp[(1) - (3)].type);
	    parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown));
    }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 829 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 831 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 834 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 836 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 838 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 840 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 842 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 844 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 846 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 848 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 850 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 852 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 854 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 856 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 858 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 860 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 862 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 864 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 866 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 868 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 870 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 872 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 874 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 876 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 878 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 880 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 882 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 884 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 887 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 889 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 891 "zparser.y"
    {
	    if (dlv_warn) {
		    dlv_warn = 0;
		    zc_warning_prev_line("DLV is experimental");
	    }
    }
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 898 "zparser.y"
    {
	    if (dlv_warn) {
		    dlv_warn = 0;
		    zc_warning_prev_line("DLV is experimental");
	    }
	    (yyval.type) = (yyvsp[(1) - (3)].type);
	    parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown));
    }
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 907 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 909 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 911 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 913 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 915 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 917 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 919 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 920 "zparser.y"
    { (yyval.type) = (yyvsp[(1) - (3)].type); parse_unknown_rdata((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].unknown)); }
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 923 "zparser.y"
    {
	    zc_error_prev_line("unrecognized RR type '%s'", (yyvsp[(1) - (3)].data).str);
	    free((yyvsp[(1) - (3)].data).str);
    }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 928 "zparser.y"
    {
    	zc_error_prev_line("parser ran out of memory!");
    	YYABORT;
    }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 941 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_a((yyvsp[(1) - (2)].data).str));
	    free((yyvsp[(1) - (2)].data).str);
    }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 948 "zparser.y"
    {
	    /* convert a single dname record */
		if ((yyvsp[(1) - (2)].domain) != NULL) {
			if (!knot_dname_is_fqdn((yyvsp[(1) - (2)].domain))) {
			knot_dname_cat((yyvsp[(1) - (2)].domain), parser->root_domain);
//			parser->current_rrset->owner =
//				knot_dname_cat($1, parser->root_domain);
			}
		}
	    zadd_rdata_domain((yyvsp[(1) - (2)].domain));
    }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 962 "zparser.y"
    {
	    /* convert the soa data */
			if (!knot_dname_is_fqdn((yyvsp[(1) - (14)].domain))) {
			knot_dname_cat((yyvsp[(1) - (14)].domain), parser->root_domain);
//			parser->current_rrset->owner =
//				knot_dname_cat($1, parser->root_domain);

		}
			if (!knot_dname_is_fqdn((yyvsp[(3) - (14)].domain))) {
			knot_dname_cat((yyvsp[(3) - (14)].domain), parser->root_domain);
//			parser->current_rrset->owner =
//				knot_dname_cat($3, parser->root_domain);

		}
	    zadd_rdata_domain((yyvsp[(1) - (14)].domain));	/* prim. ns */
	    zadd_rdata_domain((yyvsp[(3) - (14)].domain));	/* email */
	    zadd_rdata_wireformat(zparser_conv_serial((yyvsp[(5) - (14)].data).str)); /* serial */
	    zadd_rdata_wireformat(zparser_conv_period((yyvsp[(7) - (14)].data).str)); /* refresh */
	    zadd_rdata_wireformat(zparser_conv_period((yyvsp[(9) - (14)].data).str)); /* retry */
	    zadd_rdata_wireformat(zparser_conv_period((yyvsp[(11) - (14)].data).str)); /* expire */
	    zadd_rdata_wireformat(zparser_conv_period((yyvsp[(13) - (14)].data).str)); /* minimum */

	    free((yyvsp[(5) - (14)].data).str);
	    free((yyvsp[(7) - (14)].data).str);
	    free((yyvsp[(9) - (14)].data).str);
	    free((yyvsp[(11) - (14)].data).str);
	    free((yyvsp[(13) - (14)].data).str);
    }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 993 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_a((yyvsp[(1) - (6)].data).str)); /* address */
	    zadd_rdata_wireformat(zparser_conv_services((yyvsp[(3) - (6)].data).str, (yyvsp[(5) - (6)].data).str));
	    /* protocol and services */

	    free((yyvsp[(1) - (6)].data).str);
	    free((yyvsp[(3) - (6)].data).str);
	    free((yyvsp[(5) - (6)].data).str);
    }
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 1005 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_text((yyvsp[(1) - (4)].data).str, (yyvsp[(1) - (4)].data).len)); /* CPU */
	    zadd_rdata_wireformat(zparser_conv_text((yyvsp[(3) - (4)].data).str, (yyvsp[(3) - (4)].data).len)); /* OS*/

	    free((yyvsp[(1) - (4)].data).str);
	    free((yyvsp[(3) - (4)].data).str);
    }
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 1015 "zparser.y"
    {
				if (!knot_dname_is_fqdn((yyvsp[(1) - (4)].domain))) {

			knot_dname_cat((yyvsp[(1) - (4)].domain), parser->root_domain);

		}
					if (!knot_dname_is_fqdn((yyvsp[(3) - (4)].domain))) {

			knot_dname_cat((yyvsp[(3) - (4)].domain), parser->root_domain);

		}

	    /* convert a single dname record */
	    zadd_rdata_domain((yyvsp[(1) - (4)].domain));
	    zadd_rdata_domain((yyvsp[(3) - (4)].domain));
    }
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 1034 "zparser.y"
    {
					if (!knot_dname_is_fqdn((yyvsp[(3) - (4)].domain))) {
			knot_dname_cat((yyvsp[(3) - (4)].domain), parser->root_domain);
		}

	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(1) - (4)].data).str));  /* priority */
	    zadd_rdata_domain((yyvsp[(3) - (4)].domain));	/* MX host */

	    free((yyvsp[(1) - (4)].data).str);
    }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 1047 "zparser.y"
    {
	; //zadd_rdata_txt_clean_wireformat();
    }
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 1054 "zparser.y"
    {
					if (!knot_dname_is_fqdn((yyvsp[(1) - (4)].domain))) {
			knot_dname_cat((yyvsp[(1) - (4)].domain), parser->root_domain);
		}
					if (!knot_dname_is_fqdn((yyvsp[(3) - (4)].domain))) {
			knot_dname_cat((yyvsp[(3) - (4)].domain), parser->root_domain);
		}

	    zadd_rdata_domain((yyvsp[(1) - (4)].domain)); /* mbox d-name */
	    zadd_rdata_domain((yyvsp[(3) - (4)].domain)); /* txt d-name */
    }
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 1069 "zparser.y"
    {
					if (!knot_dname_is_fqdn((yyvsp[(3) - (4)].domain))) {
			knot_dname_cat((yyvsp[(3) - (4)].domain), parser->root_domain);
		}

	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(1) - (4)].data).str)); /* subtype */
	    zadd_rdata_domain((yyvsp[(3) - (4)].domain)); /* domain name */

	    free((yyvsp[(1) - (4)].data).str);
    }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 1083 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_text((yyvsp[(1) - (2)].data).str, (yyvsp[(1) - (2)].data).len));
	    /* X.25 address. */

	    free((yyvsp[(1) - (2)].data).str);
    }
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 1093 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_text((yyvsp[(1) - (2)].data).str, (yyvsp[(1) - (2)].data).len));
	    /* address */

	    free((yyvsp[(1) - (2)].data).str);
    }
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 1100 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_text((yyvsp[(1) - (4)].data).str, (yyvsp[(1) - (4)].data).len));
	    /* address */
	    zadd_rdata_wireformat(zparser_conv_text((yyvsp[(3) - (4)].data).str, (yyvsp[(3) - (4)].data).len));
	    /* sub-address */

	    free((yyvsp[(1) - (4)].data).str);
	    free((yyvsp[(3) - (4)].data).str);
    }
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 1113 "zparser.y"
    {
						if (!knot_dname_is_fqdn((yyvsp[(3) - (4)].domain))) {
			knot_dname_cat((yyvsp[(3) - (4)].domain), parser->root_domain);
		}

	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(1) - (4)].data).str)); /* preference */
	    zadd_rdata_domain((yyvsp[(3) - (4)].domain)); /* intermediate host */

	    free((yyvsp[(1) - (4)].data).str);
    }
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 1127 "zparser.y"
    {
	    /* String must start with "0x" or "0X".	 */
	    if (strncasecmp((yyvsp[(1) - (2)].data).str, "0x", 2) != 0) {
		    zc_error_prev_line("NSAP rdata must start with '0x'");
	    } else {
		    zadd_rdata_wireformat(zparser_conv_hex((yyvsp[(1) - (2)].data).str + 2,
							   (yyvsp[(1) - (2)].data).len - 2));
		    /* NSAP */
	    }

	    free((yyvsp[(1) - (2)].data).str);
    }
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 1143 "zparser.y"
    {
			if (!knot_dname_is_fqdn((yyvsp[(3) - (6)].domain))) {
				knot_dname_cat((yyvsp[(3) - (6)].domain), parser->root_domain);
		}
					if (!knot_dname_is_fqdn((yyvsp[(5) - (6)].domain))) {
				knot_dname_cat((yyvsp[(5) - (6)].domain), parser->root_domain);
		}
	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(1) - (6)].data).str)); /* preference */
	    zadd_rdata_domain((yyvsp[(3) - (6)].domain)); /* MAP822 */
	    zadd_rdata_domain((yyvsp[(5) - (6)].domain)); /* MAPX400 */

	    free((yyvsp[(1) - (6)].data).str);
    }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 1159 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_aaaa((yyvsp[(1) - (2)].data).str));
	    /* IPv6 address */

	    free((yyvsp[(1) - (2)].data).str);
    }
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 1168 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_loc((yyvsp[(1) - (2)].data).str)); /* Location */

	    free((yyvsp[(1) - (2)].data).str);
    }
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 1176 "zparser.y"
    {
				if (!knot_dname_is_fqdn((yyvsp[(1) - (4)].domain))) {
				knot_dname_cat((yyvsp[(1) - (4)].domain), parser->root_domain);
		}
	    zadd_rdata_domain((yyvsp[(1) - (4)].domain)); /* nxt name */
	    zadd_rdata_wireformat(zparser_conv_nxt(nxtbits)); /* nxt bitlist */
	    memset(nxtbits, 0, sizeof(nxtbits));
    }
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 1187 "zparser.y"
    {
				if (!knot_dname_is_fqdn((yyvsp[(7) - (8)].domain))) {
				knot_dname_cat((yyvsp[(7) - (8)].domain), parser->root_domain);

		}
	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(1) - (8)].data).str)); /* prio */
	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(3) - (8)].data).str)); /* weight */
	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(5) - (8)].data).str)); /* port */
	    zadd_rdata_domain((yyvsp[(7) - (8)].domain)); /* target name */

	    free((yyvsp[(1) - (8)].data).str);
	    free((yyvsp[(3) - (8)].data).str);
	    free((yyvsp[(5) - (8)].data).str);
    }
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 1205 "zparser.y"
    {
				if (!knot_dname_is_fqdn((yyvsp[(11) - (12)].domain))) {
				knot_dname_cat((yyvsp[(11) - (12)].domain), parser->root_domain);

		}
	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(1) - (12)].data).str)); /* order */
	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(3) - (12)].data).str)); /* preference */
	    zadd_rdata_wireformat(zparser_conv_text((yyvsp[(5) - (12)].data).str, (yyvsp[(5) - (12)].data).len));
	    /* flags */
	    zadd_rdata_wireformat(zparser_conv_text((yyvsp[(7) - (12)].data).str, (yyvsp[(7) - (12)].data).len));
	    /* service */
	    zadd_rdata_wireformat(zparser_conv_text((yyvsp[(9) - (12)].data).str, (yyvsp[(9) - (12)].data).len));
	    /* regexp */
	    zadd_rdata_domain((yyvsp[(11) - (12)].domain)); /* target name */

	    free((yyvsp[(1) - (12)].data).str);
	    free((yyvsp[(3) - (12)].data).str);
	    free((yyvsp[(5) - (12)].data).str);
	    free((yyvsp[(7) - (12)].data).str);
	    free((yyvsp[(9) - (12)].data).str);
    }
    break;

  case 179:

/* Line 1806 of yacc.c  */
#line 1230 "zparser.y"
    {
				if (!knot_dname_is_fqdn((yyvsp[(3) - (4)].domain))) {
				knot_dname_cat((yyvsp[(3) - (4)].domain), parser->root_domain);
		}
	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(1) - (4)].data).str)); /* preference */
	    zadd_rdata_domain((yyvsp[(3) - (4)].domain)); /* exchanger */

	    free((yyvsp[(1) - (4)].data).str);
    }
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 1243 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_certificate_type((yyvsp[(1) - (8)].data).str));
	    /* type */
	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(3) - (8)].data).str)); /* key tag */
	    zadd_rdata_wireformat(zparser_conv_algorithm((yyvsp[(5) - (8)].data).str));
	    /* algorithm */
	    zadd_rdata_wireformat(zparser_conv_b64((yyvsp[(7) - (8)].data).str));
	    /* certificate or CRL */

	    free((yyvsp[(1) - (8)].data).str);
	    free((yyvsp[(3) - (8)].data).str);
	    free((yyvsp[(5) - (8)].data).str);
	    free((yyvsp[(7) - (8)].data).str);
    }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 1264 "zparser.y"
    {
	    zadd_rdata_txt_wireformat(zparser_conv_apl_rdata((yyvsp[(1) - (1)].data).str), 1);

	    free((yyvsp[(1) - (1)].data).str);
    }
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 1270 "zparser.y"
    {
	    zadd_rdata_txt_wireformat(zparser_conv_apl_rdata((yyvsp[(3) - (3)].data).str), 0);

	    free((yyvsp[(3) - (3)].data).str);
    }
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 1278 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(1) - (8)].data).str)); /* keytag */
	    zadd_rdata_wireformat(zparser_conv_algorithm((yyvsp[(3) - (8)].data).str)); /* alg */
	    zadd_rdata_wireformat(zparser_conv_byte((yyvsp[(5) - (8)].data).str)); /* type */
	    zadd_rdata_wireformat(zparser_conv_hex((yyvsp[(7) - (8)].data).str, (yyvsp[(7) - (8)].data).len)); /* hash */

	    free((yyvsp[(1) - (8)].data).str);
	    free((yyvsp[(3) - (8)].data).str);
	    free((yyvsp[(5) - (8)].data).str);
	    free((yyvsp[(7) - (8)].data).str);
    }
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 1292 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(1) - (8)].data).str)); /* keytag */
	    zadd_rdata_wireformat(zparser_conv_algorithm((yyvsp[(3) - (8)].data).str)); /* alg */
	    zadd_rdata_wireformat(zparser_conv_byte((yyvsp[(5) - (8)].data).str)); /* type */
	    zadd_rdata_wireformat(zparser_conv_hex((yyvsp[(7) - (8)].data).str, (yyvsp[(7) - (8)].data).len)); /* hash */

	    free((yyvsp[(1) - (8)].data).str);
	    free((yyvsp[(3) - (8)].data).str);
	    free((yyvsp[(5) - (8)].data).str);
	    free((yyvsp[(7) - (8)].data).str);
    }
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 1306 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_byte((yyvsp[(1) - (6)].data).str)); /* alg */
	    zadd_rdata_wireformat(zparser_conv_byte((yyvsp[(3) - (6)].data).str)); /* fp type */
	    zadd_rdata_wireformat(zparser_conv_hex((yyvsp[(5) - (6)].data).str, (yyvsp[(5) - (6)].data).len)); /* hash */

	    free((yyvsp[(1) - (6)].data).str);
	    free((yyvsp[(3) - (6)].data).str);
	    free((yyvsp[(5) - (6)].data).str);
    }
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 1318 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_b64((yyvsp[(1) - (2)].data).str)); /* data blob */

	    free((yyvsp[(1) - (2)].data).str);
    }
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 1327 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_rrtype((yyvsp[(1) - (18)].data).str));
	    /* rr covered */
	    zadd_rdata_wireformat(zparser_conv_algorithm((yyvsp[(3) - (18)].data).str)); /* alg */
	    zadd_rdata_wireformat(zparser_conv_byte((yyvsp[(5) - (18)].data).str)); /* # labels */
	    zadd_rdata_wireformat(zparser_conv_period((yyvsp[(7) - (18)].data).str));
	    /* # orig TTL */
	    zadd_rdata_wireformat(zparser_conv_time((yyvsp[(9) - (18)].data).str)); /* sig exp */
	    zadd_rdata_wireformat(zparser_conv_time((yyvsp[(11) - (18)].data).str)); /* sig inc */
	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(13) - (18)].data).str)); /* key id */
/*	    zadd_rdata_wireformat(zparser_conv_dns_name((const uint8_t*)
							 $15.str,
							 $15.len));*/
	    knot_dname_t *dname =
		knot_dname_new_from_wire((uint8_t *)(yyvsp[(15) - (18)].data).str, (yyvsp[(15) - (18)].data).len, NULL);
	    knot_dname_retain(dname);
	    if (dname == NULL) {
	    	parser->error_occurred = KNOTDZCOMPILE_ENOMEM;
	    } else {
	    	knot_dname_cat(dname, parser->root_domain);
	    }

	    zadd_rdata_domain(dname);
	    /* sig name */
	    zadd_rdata_wireformat(zparser_conv_b64((yyvsp[(17) - (18)].data).str)); /* sig data */

	    free((yyvsp[(1) - (18)].data).str);
	    free((yyvsp[(3) - (18)].data).str);
	    free((yyvsp[(5) - (18)].data).str);
	    free((yyvsp[(7) - (18)].data).str);
	    free((yyvsp[(9) - (18)].data).str);
	    free((yyvsp[(11) - (18)].data).str);
	    free((yyvsp[(13) - (18)].data).str);
	    free((yyvsp[(15) - (18)].data).str);
	    free((yyvsp[(17) - (18)].data).str);
    }
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 1366 "zparser.y"
    {
/*	    zadd_rdata_wireformat(zparser_conv_dns_name((const uint8_t*)
							$1.str,
							$1.len));*/

	    knot_dname_t *dname =
		knot_dname_new_from_wire((uint8_t *)(yyvsp[(1) - (2)].data).str, (yyvsp[(1) - (2)].data).len, NULL);
	    knot_dname_retain(dname);
	    free((yyvsp[(1) - (2)].data).str);

	    knot_dname_cat(dname, parser->root_domain);

	    zadd_rdata_domain(dname);
	    /* nsec name */
	    zadd_rdata_wireformat(zparser_conv_nsec(nsecbits));
	    /* nsec bitlist */
	    memset(nsecbits, 0, sizeof(nsecbits));
	    nsec_highest_rcode = 0;
    }
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 1388 "zparser.y"
    {
#ifdef NSEC3
	    nsec3_add_params((yyvsp[(1) - (10)].data).str, (yyvsp[(3) - (10)].data).str, (yyvsp[(5) - (10)].data).str, (yyvsp[(7) - (10)].data).str, (yyvsp[(7) - (10)].data).len);

/*	    knot_dname_t *dname =
		knot_dname_new_from_str($9.str, $9.len, NULL);

	    zadd_rdata_domain(dname); */

	    zadd_rdata_wireformat(zparser_conv_b32((yyvsp[(9) - (10)].data).str));
	    /* next hashed name */
	    zadd_rdata_wireformat(zparser_conv_nsec(nsecbits));
	    /* nsec bitlist */
	    memset(nsecbits, 0, sizeof(nsecbits));
	    nsec_highest_rcode = 0;
#else
	    zc_error_prev_line("nsec3 not supported");
#endif /* NSEC3 */

	    free((yyvsp[(1) - (10)].data).str);
	    free((yyvsp[(3) - (10)].data).str);
	    free((yyvsp[(5) - (10)].data).str);
	    free((yyvsp[(7) - (10)].data).str);
	    free((yyvsp[(9) - (10)].data).str);
    }
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 1416 "zparser.y"
    {
#ifdef NSEC3
	    nsec3_add_params((yyvsp[(1) - (8)].data).str, (yyvsp[(3) - (8)].data).str, (yyvsp[(5) - (8)].data).str, (yyvsp[(7) - (8)].data).str, (yyvsp[(7) - (8)].data).len);
#else
	    zc_error_prev_line("nsec3 not supported");
#endif /* NSEC3 */

	    free((yyvsp[(1) - (8)].data).str);
	    free((yyvsp[(3) - (8)].data).str);
	    free((yyvsp[(5) - (8)].data).str);
	    free((yyvsp[(7) - (8)].data).str);
    }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 1431 "zparser.y"
    {
	zadd_rdata_wireformat(zparser_conv_byte((yyvsp[(1) - (8)].data).str));
	zadd_rdata_wireformat(zparser_conv_byte((yyvsp[(3) - (8)].data).str));
	zadd_rdata_wireformat(zparser_conv_byte((yyvsp[(5) - (8)].data).str));
	zadd_rdata_wireformat(zparser_conv_hex((yyvsp[(7) - (8)].data).str, (yyvsp[(7) - (8)].data).len));
	
	free((yyvsp[(1) - (8)].data).str);
	free((yyvsp[(3) - (8)].data).str);
	free((yyvsp[(5) - (8)].data).str);
	free((yyvsp[(7) - (8)].data).str);
    }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 1445 "zparser.y"
    {
	    zadd_rdata_wireformat(zparser_conv_short((yyvsp[(1) - (8)].data).str)); /* flags */
	    zadd_rdata_wireformat(zparser_conv_byte((yyvsp[(3) - (8)].data).str)); /* proto */
	    zadd_rdata_wireformat(zparser_conv_algorithm((yyvsp[(5) - (8)].data).str)); /* alg */
	    zadd_rdata_wireformat(zparser_conv_b64((yyvsp[(7) - (8)].data).str)); /* hash */

	    free((yyvsp[(1) - (8)].data).str);
	    free((yyvsp[(3) - (8)].data).str);
	    free((yyvsp[(5) - (8)].data).str);
	    free((yyvsp[(7) - (8)].data).str);
    }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 1459 "zparser.y"
    {
	    knot_dname_t* name = 0;
	    zadd_rdata_wireformat(zparser_conv_byte((yyvsp[(1) - (7)].data).str)); /* precedence */
	    zadd_rdata_wireformat(zparser_conv_byte((yyvsp[(3) - (7)].data).str));
	    /* gateway type */
	    zadd_rdata_wireformat(zparser_conv_byte((yyvsp[(5) - (7)].data).str)); /* algorithm */
	    switch(atoi((yyvsp[(3) - (7)].data).str)) {
		case IPSECKEY_NOGATEWAY:
			zadd_rdata_wireformat(alloc_rdata_init("", 0));
			break;
		case IPSECKEY_IP4:
			zadd_rdata_wireformat(zparser_conv_a((yyvsp[(7) - (7)].data).str));
			break;
		case IPSECKEY_IP6:
			zadd_rdata_wireformat(zparser_conv_aaaa((yyvsp[(7) - (7)].data).str));
			break;
		case IPSECKEY_DNAME:
			/* convert and insert the dname */
			if(strlen((yyvsp[(7) - (7)].data).str) == 0)
				zc_error_prev_line("IPSECKEY must specify"
						   "gateway name");
			name = knot_dname_new_from_str((yyvsp[(7) - (7)].data).str,
							  strlen((yyvsp[(7) - (7)].data).str),
							  NULL);
			if(!name) {
				zc_error_prev_line("IPSECKEY bad gateway"
						   "dname %s", (yyvsp[(7) - (7)].data).str);
				knot_rrset_deep_free(&(parser->current_rrset),
						                          0, 0, 0);
				knot_zone_deep_free(&(parser->current_zone),
						      1);
				YYABORT;
			}

			if(!knot_dname_is_fqdn(name)) {
			    assert(parser->origin);
			    name = knot_dname_cat(name,
				    parser->origin->owner);
			    if (name == NULL) {
			    	zc_error_prev_line("Cannot concatenete dnames, probably run out of memory!\n");
				YYABORT;
			    }
			}

			free((yyvsp[(1) - (7)].data).str);
			free((yyvsp[(3) - (7)].data).str);
			free((yyvsp[(5) - (7)].data).str);
			free((yyvsp[(7) - (7)].data).str);

			uint16_t* dncpy = malloc(sizeof(uint8_t) * name->size + 2);
			dncpy[0] = name->size;
			if (dncpy == NULL) {
			    ERR_ALLOC_FAILED;
			    knot_rrset_deep_free(&(parser->current_rrset),
			                           0, 0, 0);
			    knot_zone_deep_free(&(parser->current_zone),
			                          1);
			    YYABORT;
			}
			
			memcpy((uint8_t *)(dncpy + 1), name->name, name->size);
			zadd_rdata_wireformat(dncpy);
			knot_dname_free(&name);
			break;
		default:
			zc_error_prev_line("unknown IPSECKEY gateway type");
	    }
    }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 1530 "zparser.y"
    {
	   zadd_rdata_wireformat(zparser_conv_b64((yyvsp[(3) - (4)].data).str)); /* public key */

		 free((yyvsp[(3) - (4)].data).str);
    }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 1539 "zparser.y"
    {
	    /* $2 is the number of octects, currently ignored */
	    (yyval.unknown) = zparser_conv_hex((yyvsp[(5) - (6)].data).str, (yyvsp[(5) - (6)].data).len);
	    free((yyvsp[(5) - (6)].data).str);
	    free((yyvsp[(3) - (6)].data).str);
    }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 1546 "zparser.y"
    {
	    (yyval.unknown) = zparser_conv_hex("", 0);
	    free((yyvsp[(3) - (4)].data).str);
    }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 1551 "zparser.y"
    {
	    (yyval.unknown) = zparser_conv_hex("", 0);
    }
    break;



/* Line 1806 of yacc.c  */
#line 4015 "zparser.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (scanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (scanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, scanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, scanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (scanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, scanner);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, scanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 1555 "zparser.y"


int zp_wrap(void)
{
	return 1;
}

/*
 * Create the parser.
 */
zparser_type *zparser_create()
{
	zparser_type *result = malloc(sizeof(zparser_type));
	if (result == NULL) {
	    ERR_ALLOC_FAILED;
	    return NULL;
	}

	result->temporary_items = malloc(MAXRDATALEN *
					  sizeof(knot_rdata_item_t));
	if (result->temporary_items == NULL) {
		ERR_ALLOC_FAILED;
		free(result);
		return NULL;
	}

	result->current_rrset = knot_rrset_new(NULL, 0, 0, 0);
	if (result->current_rrset == NULL) {
		free(result->temporary_items);
		free(result);
		return NULL;
	}

	result->root_domain = knot_dname_new_from_str(".", 1, NULL);
	if (result->root_domain == NULL) {
		free(result->temporary_items);
		free(result->current_rrset);
		free(result);
		return NULL;
	}

	return result;
}

/*
 * Initialize the parser for a new zone file.
 */
void
zparser_init(const char *filename, uint32_t ttl, uint16_t rclass,
	     knot_node_t *origin, knot_dname_t *origin_from_config)
{
	memset(nxtbits, 0, sizeof(nxtbits));
	memset(nsecbits, 0, sizeof(nsecbits));
	nsec_highest_rcode = 0;

	parser->current_zone = NULL;
	parser->prev_dname = NULL;

	parser->default_ttl = ttl;
	parser->default_class = rclass;

	parser->origin = origin;
	parser->prev_dname = NULL;//parser->origin->owner;

	parser->default_apex = origin;
	parser->error_occurred = 0;
	parser->errors = 0;
	parser->line = 1;
	parser->filename = filename;
	parser->rdata_count = 0;
	parser->origin_from_config = origin_from_config;
	knot_dname_retain(origin_from_config);

	parser->last_node = origin;
//	parser->root_domain = NULL;

	/* Create zone */
	parser->current_zone = knot_zone_new(origin, 0, 1);

	parser->node_rrsigs = NULL;

	parser->current_rrset->rclass = parser->default_class;
	parser->current_rrset->rdata = NULL;
}


void zparser_free()
{
	knot_dname_release(parser->root_domain);
//	knot_dname_release(parser->prev_dname);
	knot_zone_deep_free(&parser->current_zone, 1);
	knot_dname_release(parser->origin_from_config);
	free(parser->temporary_items);
	if (parser->current_rrset != NULL) {
		free(parser->current_rrset);
	}
	free(parser);
}

void
yyerror(void *scanner, const char *message)
{
	zc_error("%s", message);
}

static void
error_va_list(unsigned line, const char *fmt, va_list args)
{
	char sbuf[4096] = {0};
	size_t buflen = sizeof(sbuf) - 1;
	char *buf = sbuf;
	int wb = 0;
	if (parser->filename) {
		wb = snprintf(buf, buflen, "%s:%u: ",
		              parser->filename, line);
		if (wb > 0) {
			buf += wb;
			buflen -= wb;
		}
	}
	
	wb = vsnprintf(buf, buflen, fmt, args);
	if (wb > 0) {
		buf += wb;
		buflen -= wb;
		*buf = '\n';
		*(buf + 1) = '\0';
	}
	
	log_zone_error("%s", sbuf);
	
	++parser->errors;
	parser->error_occurred = 1;
}

/* the line counting sux, to say the least
 * with this grose hack we try do give sane
 * numbers back */
void
zc_error_prev_line(const char *fmt, ...)
{
	va_list args;
	va_start(args, fmt);
	error_va_list(parser->line - 1, fmt, args);
	va_end(args);
}

void
zc_error(const char *fmt, ...)
{
	/* send an error message to stderr */
	va_list args;
	va_start(args, fmt);
	error_va_list(parser->line, fmt, args);
	va_end(args);
}

static void
warning_va_list(unsigned line, const char *fmt, va_list args)
{
	char sbuf[4096] = {0};
	size_t buflen = sizeof(sbuf) - 1;
	char *buf = sbuf;
	int wb = 0;
	if (parser->filename) {
		wb = snprintf(buf, buflen, "%s:%u: ",
		              parser->filename, line);
		if (wb > 0) {
			buf += wb;
			buflen -= wb;
		}
	}

	wb = vsnprintf(buf, buflen, fmt, args);
	if (wb > 0) {
		buf += wb;
		buflen -= wb;
		*buf = '\n';
		*(buf + 1) = '\0';
	}

	log_zone_warning("%s", sbuf);
}

void
zc_warning_prev_line(const char *fmt, ...)
{
	va_list args;
	va_start(args, fmt);
	warning_va_list(parser->line - 1, fmt, args);
	va_end(args);
}

void
zc_warning(const char *fmt, ... )
{
	va_list args;
	va_start(args, fmt);
	warning_va_list(parser->line, fmt, args);
	va_end(args);
}

#ifdef NSEC3
static void
nsec3_add_params(const char* hashalgo_str, const char* flag_str,
	const char* iter_str, const char* salt_str, int salt_len)
{
	zadd_rdata_wireformat(zparser_conv_byte(hashalgo_str));
	zadd_rdata_wireformat(zparser_conv_byte(flag_str));
	zadd_rdata_wireformat(zparser_conv_short(iter_str));

	/* salt */
	if(strcmp(salt_str, "-") != 0)
		zadd_rdata_wireformat(zparser_conv_hex_length(salt_str,
							      salt_len));
	else
		zadd_rdata_wireformat(alloc_rdata_init("", 1));

}
#endif /* NSEC3 */

